//
// ********************************************************************
// *                                                                  *
// *                                                                  *
// *                                                                  *
// ********************************************************************
//


#include "TTree.h"
#include "outTree.h"
#include "globals.hh"
#include "G4UserEventAction.hh"

class myPrimaryGeneratorAction;

class G4Event;

// ********************************************************************

class myEventAction : public G4UserEventAction
{
public:
  myEventAction(myPrimaryGeneratorAction*);
  ~myEventAction();
  
public: 
  void SetOutTree(TTree*);
  void SetOutTreeStruct(tpol1_t *sTmp){tpol1Ptr = sTmp;};
  void BeginOfEventAction(const G4Event*);
  void EndOfEventAction(const G4Event*);
  void AddRingEnergy(G4double de, G4int ringID, G4int sectorID) {ringEnergy[ringID][sectorID] += de;}
  void AddRingEnergyPart(G4double de, G4int ringID, G4int sectorID) {ringEnergyPart[ringID][sectorID] += de;}
  G4double GetRingEnergy(G4int ringID,G4int sectorID){return ringEnergy[ringID][sectorID];};
  void  AddNRecoil() {nRecoil++;};
  void  AddNDeltaRay() {nDeltaRay++;};
  G4int GetNRecoil() {return nRecoil;};
  G4int GetNDeltaRay() {return nDeltaRay;};
  G4int GetNHits();
  void MakeSectorEnergy();
  G4int GetNRingHits();
  G4int GetNSectorHits();
  G4int GetSector();
  G4int GetSectorN(int hitN);
  G4int GetRing();  
  G4double GetAngle(G4int sectorID);
  G4double GetEdep();
  G4double GetSectorEdep(int sector);
  G4double GetEdepPart();
  int GetADC(G4double eDep);

  ////////////////
  TTree* outTree;
  tpol1_t *tpol1Ptr;
  G4double ringEnergy[24][32],ringEnergyPart[24][32],sectorEnergy[32];
  G4int nRecoil,nDeltaRay;
  myPrimaryGeneratorAction* primary;
};

// ********************************************************************


    
